/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014,2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 619 2014-03-18 06:10:27Z nmir-saito $
 */

/*
 *  åװ¸⥸塼 ֥AT91SKYEYEѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */

#include "kernel_impl.h"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥
 */
	.text
	.align 2
	.global hardware_init_hook
	.type hardware_init_hook, function
hardware_init_hook:
	bx  lr

/*
 * ߥϥɥ
 *
 * IRQ 㳰٥ƤӽФ
 */
	.text
	.align 2
	.global irq_handler
	.type irq_handler, function
irq_handler:
	/* 
	 * IRQ⡼ɤǼ¹Ԥ
	 */
	/* 
	 *  Υ⡼(ѡХ⡼)
	 *  ܹԤƥȤ¸
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_IRQ_BIT) 
	/* 
	 *  ƥȤ SV⡼ɤΥå¸
	 */
	stmfd sp!, {r0-r3, ip, lr, pc} /* pcϥߡ */

	/*
	 * spsrϤ뤿IRQ⡼ɤ
	 */
	msr   cpsr_cxsf, #(CPSR_IRQ | CPSR_IRQ_BIT)
	/* lr_irq  r0  */
	sub   r0, lr, #4
	/* spsr_irq  r1  */
	mrs   r1, spsr

	/* װֹ r3  */
	ldr   r3, =AIC_IVR
	ldr   r3, [r3]

	/*
	 *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_IRQ_BIT) 
	/*
	 *  Ϥ spsr 򥹡ѡХ⡼ѤΥåѤ
	 */
	str   r0, [sp, #0x18] /* Ϥ򥹥å */
	stmfd sp!, {r1}       /* spsr򥹥å¸ */
	mov   lr, sp          /* λΥåΤ */

	/*
	 *  ͥȲΥ󥯥
	 */
	ldr   r2, =excpt_nest_count /* 㳰ߥͥȲ */
	ldr   r1, [r2]
	add   r0, r1, #1            /* 㳰ߥͥȲ򹹿 */
	str   r0, [r2]

irq_handler_1:
	stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

	/*
	 *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
	 *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
	 *  ¸롥
	 */
	ldr   r0, =inh_ipm_tbl      /* ͥ٤ */
	ldr   r1, [r0, r3, lsl #2]  /* r1<-ͥ   */
	ldr   r0, =ipm              /* ȯγͥ٥ޥ򥹥å¸ */
	ldr   r2, [r0]              
	stmfd sp!,{r2}         
	str   r1, [r0]              /* (ǥ)ͥ٥ޥ򥻥å */

	/*
	 * ϡɥ(IRC)ϳߤդ塤ߤ˱ͥ٥ޥ
	 * 򥻥åȤ롥Τ᥽եȥŪˤä˽ϹԤɬפϤʤ
	 * եȥŪ(ǥ)ͥ٥ޥ夲ݤˤϡ
	 * ͥ٥ޥ˱Ƴ׵ػߥե饰ˤߤػߤ롥
	 */
	/*
	 *  ߥϥɥεưϤ
	 */
	ldr   r0, =inh_tbl         /* ߥϥɥơ֥ɤ߽Ф  */
	ldr   r0, [r0, r3, lsl #2] /* r0<-ߥϥɥ            */    
	
	stmfd sp!,{r3}             /* inhno ¸  */

	/* 
	 * ߵ 
	 */         
	msr   cpsr_cxsf, #(CPSR_SVC)

#ifdef LOG_INH_ENTER
	stmfd sp!,{r0}
	mov   r0, r3         /* inhno ѥ᡼    */
	bl    log_inh_enter  /* log_inh_enterƤӽФ */
	ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

	/* 
	 * ߥϥɥθƤӽФ
	 */
	mov   lr, pc
	bx    r0

	ldmfd sp!,{r0}       /* inhno   */    
#ifdef LOG_INH_LEAVE
	bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

	/*
	 * ͥγߤػߤ
	 */
/*    msr   cpsr, #(CPSR_SVC AOR CPSR_IRQ_BIT)*/
	mrs	r3, cpsr
	and	r3, r3, #CPSR_FIQ_BIT
	orr	r3, r3, #(CPSR_SVC|CPSR_IRQ_BIT)
	msr	cpsr, r3
	
	/*
	 * ߥꥢ
	 */
	ldr   r3, =AIC_EOI
	mov   r0, #0
	str   r0, [r3]

	b     target_ret_int

/*
 *
 * åȰ¸㳰
 *
 */
	.text
	.global target_exc_handler
	.type target_exc_handler, function
target_exc_handler:
    /*
	 *  (1)ư⡼ɡ줾㳰⡼(r2˼बǼƤ)
	 *        (2)r1 : spsr
	 *        (3)r0 : lr(ȯPC)
	 *        (4)å: r0-r3,ip,lr,pc ץåѤ
	 *  ѡХ⡼ɤذܹԡߥå
	 *  ߥå֡CPUå֤CPU㳰ȯ
	 *  ֤Ѿ롥
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_FIQ_BIT | CPSR_IRQ_BIT) 
	str   r0, [sp, #0x18] /* Ϥ򥹥åPCΰ֤ */
	stmfd sp!, {r1}       /* spsr򥹥å¸ */    
	mov   lr, sp          /* λΥåΤ */

	ldr   r0, =ipm        /* ȯγͥ٥ޥ򥹥å¸ */
	ldr   r1, [r0]              
	stmfd sp!, {r1}

	/* 
	 * ƥȽΤᡤexcpt_nest_count 򥹥å¸
	 * å¸ߤexcpt_nest_count-1ȼǤ뤬
	 * åѤǤǥХåԤ䤹Τǡå
	 * ¸롥
	 */
	ldr   r0, =excpt_nest_count
	ldr   r1, [r0]
	stmfd sp!, {r1}
	mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

	/*
	 *  ͥȥ󥿤򥤥󥯥
	 */
	ldr   r0, =excpt_nest_count
	ldr   r1, [r0]
	add   r1, r1, #1
	str   r1, [r0]

target_exc_handler_1:
	stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

	/* 
	 * ȯγͥ٥ޥ򥹥å¸ 
	 * ߥϥɥȽи롼ͭ뤿¸
	 */
	ldr   r0, =ipm       
	ldr   r1, [r0]              
	stmfd sp!, {r1}

	/*
	 *  CPU㳰ϥɥεưϤ
	 */
	ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
	ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

	stmfd sp!,{r2}      /* excno ¸ */

	/* 
	 * ߵ 
	 * CPUå֡ߥå֤ϷѾ
	 */         
	ldr   r0, [lr]
	and   r0, r0, #(CPSR_IRQ_BIT|CPSR_FIQ_BIT)
	orr   r0, r0, #(CPSR_SVC)
	msr   cpsr, r0

#ifdef LOG_EXC_ENTER
	stmfd sp!,{r1,r3}
	mov   r0, r2         /* excno ѥ᡼    */
	bl    log_exc_enter  /* log_exc_enterƤӽФ */
	ldmfd sp!,{r1,r3}
#endif /* LOG_EXC_ENTER */

	/* 
	 * CPU㳰ϥɥθƤӽФ
	 * 㳰ե졼ƬȤϤ
	 */        
	mov   r0, r3
	mov   lr, pc
	bx    r1

	ldmfd sp!,{r0}       /* excno   */    
#ifdef LOG_EXC_LEAVE
	bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */


	/*
	 * ͥγߤػߤ
	 */
	msr   cpsr_cxsf, #(CPSR_SVC | CPSR_IRQ_BIT)  

	/*
	 * и(åȰ¸)
	 * irq_handler ȤϤǹή
	 */
	.global target_ret_int
	.type target_ret_int, function
target_ret_int:
	/*
	 * ͥ٥ޥ򸵤᤹
	 */
	ldmfd sp!, {r1}             /* γͥ٥ޥ */
	ldr   r0, =ipm              /* ͥ٥ޥ     */
	str   r1, [r0]
	rsb   r1, r1,  #0           /* ǥåȤʤ褦ȿž */
	ldr   r0, =ipm_mask_tbl     /* (ǥ)γͥ٤Τ¸뤿 */
	ldr   r2, [r0, r1, lsl #2]  /* ׵ػߥե饰 */    
	ldr   r0, =idf              /* Ƴߤγ׵ػߥե饰ξ֤ */
	ldr   r1, [r0]
	/*
	 * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
	 * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
	 * IRCγߵĥ쥸ؤͤꤹ롥
	 */
	mvn   lr, #0                
	/* äߤγ׵ޥ */
	ldr   r0, =AIC_IDCR
	str   lr, [r0]
	orr   r1, r1, r2            /* ޥꤵƤʤߤε */
	mvn   r1, r1                /* ͤ */    
	ldr   r0, =AIC_IECR
	str   r1, [r0]

	/*
	 * åݥ󥿤
	 */
	ldmfd sp!, {r2}             /* Υåݥ󥿤 */
	mov   sp, r2

	/*
	 * νARM¸Ǽ¹
	 */            
	b     ret_int


/* ʹߡNot Yet! */

/*
 * ͥCPU㳰ν
 */
 	.global target_kernel_unc_exc_handler
 	.type target_kernel_unc_exc_handler, function
target_kernel_unc_exc_handler:
	/*
	 * ͥȥȤ򥤥󥯥
	 */
	ldr   r0, =excpt_nest_count
	ldr   r1, [r0]
	add   r1, r1, #1
	str   r1, [r0]

target_kernel_unc_exc_handler_1:
	stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

	/*
	 *  CPU㳰ϥɥεưϤ
	 */
	ldr   r0, =exch_tbl        /* ߥϥɥơ֥ɤ߽Ф */
	ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

	/*
	 * ƥ֡ʥƥȤϽˤCPU㳰ȯξ֤
	 */
	ldr   r0, [lr]             /* CPU㳰ȯCPSRμ */
	and   r0, r0, #(CPSR_IRQ_BIT | CPSR_FIQ_BIT)
	orr   r0, r0, #(CPSR_SVC)
	msr   cpsr_cxsf, r0

	/* 
	 * CPU㳰ϥɥθƤӽФ
	 * 㳰ե졼ƬȤϤ
	 */        
	mov   r0, r3
	mov   lr, pc
	bx    r1

	/*
	 *  㳰ߤΥͥȥȡexcpt_nest_count)Υǥ
	 */        
	ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
	ldr   r1, [r0]
	sub   r2, r1, #1
	str   r2, [r0]

	/*
	 * åݥ󥿤
	 */
	ldmfd sp!, {r2}             /* Υåݥ󥿤 */
	mov   sp, r2

	/*
	 * CPU㳰
	 */
	ldmfd sp!,{r1}              /* CPSR */
	msr   spsr_cxsf, r1         /* cpsrspsr */
	ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ƥȤ^դʤΤǡcpsr <- spsr */
